org.opencv.ximgproc

## Class SuperpixelSEEDS

- java.lang.Object
- - org.opencv.core.Algorithm
  - - org.opencv.ximgproc.SuperpixelSEEDS

-     public class SuperpixelSEEDS
      extends Algorithm

  Class implementing the SEEDS (Superpixels Extracted via Energy-Driven Sampling) superpixels algorithm described in CITE: VBRV14 . The algorithm uses an efficient hill-climbing algorithm to optimize the superpixels' energy function that is based on color histograms and a boundary term, which is optional. The energy function encourages superpixels to be of the same color, and if the boundary term is activated, the superpixels have smooth boundaries and are of similar shape. In practice it starts from a regular grid of superpixels and moves the pixels or blocks of pixels at the boundaries to refine the solution. The algorithm runs in real-time using a single CPU.

- - ### Field Summary

    - ### Fields inherited from class org.opencv.core.Algorithm

      `nativeObj`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `SuperpixelSEEDS(long addr)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static SuperpixelSEEDS` | `__fromPtr__(long addr)`
    `protected void` | `finalize()`
    `void` | `getLabelContourMask(Mat image)` Returns the mask of the superpixel segmentation stored in SuperpixelSEEDS object.
    `void` | `getLabelContourMask(Mat image, boolean thick_line)` Returns the mask of the superpixel segmentation stored in SuperpixelSEEDS object.
    `void` | `getLabels(Mat labels_out)` Returns the segmentation labeling of the image.
    `int` | `getNumberOfSuperpixels()` Calculates the superpixel segmentation on a given image stored in SuperpixelSEEDS object.
    `void` | `iterate(Mat img)` Calculates the superpixel segmentation on a given image with the initialized parameters in the SuperpixelSEEDS object.
    `void` | `iterate(Mat img, int num_iterations)` Calculates the superpixel segmentation on a given image with the initialized parameters in the SuperpixelSEEDS object.

    - ### Methods inherited from class org.opencv.core.Algorithm

      `clear, empty, getDefaultName, getNativeObjAddr, save`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SuperpixelSEEDS

          protected SuperpixelSEEDS(long addr)

  - ### Method Detail

    - #### __fromPtr__

          public static SuperpixelSEEDS __fromPtr__(long addr)

    - #### getNumberOfSuperpixels

          public int getNumberOfSuperpixels()

      Calculates the superpixel segmentation on a given image stored in SuperpixelSEEDS object. The function computes the superpixels segmentation of an image with the parameters initialized with the function createSuperpixelSEEDS().
      Returns:
        automatically generated

    - #### getLabelContourMask

          public void getLabelContourMask(Mat image,
                                          boolean thick_line)

      Returns the mask of the superpixel segmentation stored in SuperpixelSEEDS object.
      Parameters:
        `image` - Return: CV_8UC1 image mask where -1 indicates that the pixel is a superpixel border, and 0 otherwise.
        `thick_line` - If false, the border is only one pixel wide, otherwise all pixels at the border are masked. The function return the boundaries of the superpixel segmentation. Note:
        - (Python) A demo on how to generate superpixels in images from the webcam can be found at opencv_source_code/samples/python2/seeds.py
          - (cpp) A demo on how to generate superpixels in images from the webcam can be found at opencv_source_code/modules/ximgproc/samples/seeds.cpp. By adding a file image as a command line argument, the static image will be used instead of the webcam.
          - It will show a window with the video from the webcam with the superpixel boundaries marked in red (see below). Use Space to switch between different output modes. At the top of the window there are 4 sliders, from which the user can change on-the-fly the number of superpixels, the number of block levels, the strength of the boundary prior term to modify the shape, and the number of iterations at pixel level. This is useful to play with the parameters and set them to the user convenience. In the console the frame-rate of the algorithm is indicated.
          ![image](pics/superpixels_demo.png)

    - #### getLabelContourMask

          public void getLabelContourMask(Mat image)

      Returns the mask of the superpixel segmentation stored in SuperpixelSEEDS object.
      Parameters:
        `image` - Return: CV_8UC1 image mask where -1 indicates that the pixel is a superpixel border, and 0 otherwise. are masked. The function return the boundaries of the superpixel segmentation. Note:
        - (Python) A demo on how to generate superpixels in images from the webcam can be found at opencv_source_code/samples/python2/seeds.py
          - (cpp) A demo on how to generate superpixels in images from the webcam can be found at opencv_source_code/modules/ximgproc/samples/seeds.cpp. By adding a file image as a command line argument, the static image will be used instead of the webcam.
          - It will show a window with the video from the webcam with the superpixel boundaries marked in red (see below). Use Space to switch between different output modes. At the top of the window there are 4 sliders, from which the user can change on-the-fly the number of superpixels, the number of block levels, the strength of the boundary prior term to modify the shape, and the number of iterations at pixel level. This is useful to play with the parameters and set them to the user convenience. In the console the frame-rate of the algorithm is indicated.
          ![image](pics/superpixels_demo.png)

    - #### getLabels

          public void getLabels(Mat labels_out)

      Returns the segmentation labeling of the image. Each label represents a superpixel, and each pixel is assigned to one superpixel label.
      Parameters:
        `labels_out` - Return: A CV_32UC1 integer array containing the labels of the superpixel segmentation. The labels are in the range [0, getNumberOfSuperpixels()]. The function returns an image with ssthe labels of the superpixel segmentation. The labels are in the range [0, getNumberOfSuperpixels()].

    - #### iterate

          public void iterate(Mat img,
                              int num_iterations)

      Calculates the superpixel segmentation on a given image with the initialized parameters in the SuperpixelSEEDS object. This function can be called again for other images without the need of initializing the algorithm with createSuperpixelSEEDS(). This save the computational cost of allocating memory for all the structures of the algorithm.
      Parameters:
        `img` - Input image. Supported formats: CV_8U, CV_16U, CV_32F. Image size & number of channels must match with the initialized image size & channels with the function createSuperpixelSEEDS(). It should be in HSV or Lab color space. Lab is a bit better, but also slower.
        `num_iterations` - Number of pixel level iterations. Higher number improves the result. The function computes the superpixels segmentation of an image with the parameters initialized with the function createSuperpixelSEEDS(). The algorithms starts from a grid of superpixels and then refines the boundaries by proposing updates of blocks of pixels that lie at the boundaries from large to smaller size, finalizing with proposing pixel updates. An illustrative example can be seen below. ![image](pics/superpixels_blocks2.png)

    - #### iterate

          public void iterate(Mat img)

      Calculates the superpixel segmentation on a given image with the initialized parameters in the SuperpixelSEEDS object. This function can be called again for other images without the need of initializing the algorithm with createSuperpixelSEEDS(). This save the computational cost of allocating memory for all the structures of the algorithm.
      Parameters:
        `img` - Input image. Supported formats: CV_8U, CV_16U, CV_32F. Image size & number of channels must match with the initialized image size & channels with the function createSuperpixelSEEDS(). It should be in HSV or Lab color space. Lab is a bit better, but also slower. The function computes the superpixels segmentation of an image with the parameters initialized with the function createSuperpixelSEEDS(). The algorithms starts from a grid of superpixels and then refines the boundaries by proposing updates of blocks of pixels that lie at the boundaries from large to smaller size, finalizing with proposing pixel updates. An illustrative example can be seen below. ![image](pics/superpixels_blocks2.png)

    - #### finalize

          protected void finalize()
                           throws Throwable

      Overrides:
        `finalize` in class `Algorithm`
      Throws:
        `Throwable`

Generated on Wed Oct 9 2019 16:55:37 UTC / OpenCV 3.4.8